clear
close all
clc

% read in data

filename = 'test.asc'

nc = neur_converterh(filename);

% simulation time

simd.dt = 0.025;   % ms
simd.T = 50;    % ms

simd.Is.start = 10;  % ms
simd.Is.end = 40;   % ms

% current pulse

simd.Is.mag = 300e-3;  % uA
%simd.Is.mag = 0;  % nA

simd.t = 0:simd.dt:simd.T;

% construct morphology

md = neur_loadmorph_direct(nc,499,1)

% parameters

p_const = neur_param_const(nc);
p_conds = neur_param_conds(nc,md);

% M K L

[M, K, L, b, md] = neur_assembleMKh(nc,md,p_const,p_conds);

save ncmd nc md

% Hines solver

disp('M,K,L ready')

disp('Solving system...')

% solve for v

tic
[v,t] = neur_solverh(M,K,L,b,md,p_const,p_conds,simd,filename);
toc

fprintf('\n')

load fiber500 data
load fiber500e 

out = neur_read(filename);

plot(data(:,1),out.v(end,:))
hold on
plot(data(:,1),data(:,2),'r--','linewidth',2)
plot(data(:,1),out.v(1,:))
plot(data(:,1),dataend(:,2),'r--','linewidth',2)
figure
plot(data(:,1),out.v(end,:)'-data(:,2))
hold on
plot(data(:,1),out.v(1,:)'-dataend(:,2),'g')
title('error: matlab minus neuron')