function hines_solver(M,K,L,nc,md,parm,simd,filename)

WRITEF1 = fopen([filename '.n1'],'w');
WRITEF2 = fopen([filename '.n2'],'w');
WRITEF3 = fopen([filename '.n3'],'w');

fwrite(WRITEF3,md.count.L,'double');
fwrite(WRITEF3,md.count.N,'double');
fwrite(WRITEF3,md.segh,'double');
fwrite(WRITEF3,md.segt,'double');

fwrite(WRITEF2,simd.t,'double');

N = md.count.L;

LHS = M+simd.dt*(L+K);

% [L,U] = lu(LHS);

io = neur_stimulus(md,simd);

tl = length(simd.t);

eo = zeros(N,1);

% current pulse at the SOMA

eo(end) = 1;

j = 2;
t(1) = 0;
v = zeros(N,1); 

fwrite(WRITEF1,v,'double');

jfinal = simd.T/simd.dt;
jtenper = jfinal/10;

while (j-1)*simd.dt <= simd.T

   t(j) = (j-1)*simd.dt;

   RHS = M*v+io(j-1)*eo*simd.dt; 
 
   %v = U \ (L \ RHS);

   v(:,j) = hines(LHS,RHS,nc,md);
   
   fwrite(WRITEF1,v,'double');
   
   j = j + 1;

   if mod(j,jtenper) == 0 
    
       disp([num2str(j/jtenper*10) ' % done'])
       
   end
 
end

function io = neur_stimulus(md,simd)

if simd.Is.end > simd.T
   simd.Is.end = simd.T;
end

io = zeros(length(simd.t),1);

startindex = simd.Is.start/simd.dt;
endindex = simd.Is.end/simd.dt;

io(startindex:endindex) = simd.Is.mag*1/(2*pi);